'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useScrap = undefined;

var _awsSdk = require('aws-sdk');

var _awsSdk2 = _interopRequireDefault(_awsSdk);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _stream = require('stream');

var _scrapDansTesMains = require('scrap-dans-tes-mains');

var _webshot = require('webshot');

var _webshot2 = _interopRequireDefault(_webshot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var useScrap = exports.useScrap = function useScrap(app, config) {
  // unpack
  var awsConfig = config.awsConfig,
      bucketName = config.bucketName,
      routePath = config.routePath,
      webshotsBucket = config.webshotsBucket;
  // update

  var s3 = new _awsSdk2.default.S3();
  _awsSdk2.default.config.update(awsConfig);
  // s3
  var getWebshotUrl = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt('return', new Promise(function (resolve, reject) {
                var fileName = url
                //.split('?')[0]
                .replace(/\/$/, '').replace(/\//g, '-').replace(/\./g, '_');
                var getObjectConfig = {
                  Bucket: bucketName,
                  Key: 'webshots/' + fileName
                };
                var uploadConfig = Object.assign({
                  ContentType: 'image/png',
                  ACL: 'public-read'
                }, getObjectConfig);
                // check first
                s3.headObject(uploadConfig, function (err, metadata) {
                  // handle no object on cloud here
                  if (err && err.code === 'NotFound') {
                    reject(err);
                  } else {
                    // Try to get an existing object
                    s3.getObject(getObjectConfig).on('success', function (response) {
                      // just get the signedUrl
                      s3.getSignedUrl('getObject', getObjectConfig, function (err, signedUrl) {
                        if (err) {
                          reject(err);
                          return;
                        } else if (signedUrl) {
                          var webshotUrl = signedUrl.split('?')[0];
                          resolve(webshotUrl);
                        }
                      });
                    }).on('error', function (error) {
                      // do the webshot
                      var renderStream = (0, _webshot2.default)(url, function (err, stream) {
                        uploadConfig.Body = new _stream.Readable().wrap(stream);
                        s3.upload(uploadConfig, function (err, payload) {
                          if (err) {
                            reject(err);
                          } else {
                            resolve(payload.Location);
                          }
                        });
                      });
                    }).send();
                  }
                });
              }).catch(function (err) {
                return console.warn(err);
              }));

            case 1:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function getWebshotUrl(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  // get
  app.get(routePath, function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res) {
      var url, json, webshotUrl;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // unpack
              url = req.query.url;
              // json

              json = {};
              // try

              _context2.prev = 2;
              _context2.next = 5;
              return (0, _scrapDansTesMains.scrap)(url);

            case 5:
              json.scrap = _context2.sent;
              _context2.t0 = json.scrap;

              if (!_context2.t0) {
                _context2.next = 11;
                break;
              }

              _context2.next = 10;
              return getWebshotUrl(url);

            case 10:
              _context2.t0 = _context2.sent;

            case 11:
              webshotUrl = _context2.t0;

              json.webshotUrl = webshotUrl;
              //
              _context2.next = 19;
              break;

            case 15:
              _context2.prev = 15;
              _context2.t1 = _context2['catch'](2);

              json.error = _context2.t1;
              console.warn('scrap api', _context2.t1);

            case 19:
              // send
              res.json(json);

            case 20:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined, [[2, 15]]);
    }));

    return function (_x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }());
  // get
  app.get(routePath + '/exists', function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(req, res) {
      var url;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              // unpack
              url = req.query.url;
              // fetch

              (0, _nodeFetch2.default)(decodeURIComponent(url)).then(function (result) {
                res.json({ isExistingUrl: result.ok && result.status === 200 && result.headers.get('content-type').includes('text/html')
                });
              }).catch(function (error) {
                console.warn(error);
                res.json({ error: error, isExistingUrl: false });
              });

            case 2:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));

    return function (_x4, _x5) {
      return _ref3.apply(this, arguments);
    };
  }());
};